/*
 * Product Ordering
 *
 * **TMF API Reference : TMF 622 - Product Ordering Management**  **Release : 19.0 - June 2019**  The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.  The product order references the product offer and identifies any specific requests made by the customer.  **Product Order resource** A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.  Product Order API performs the following operations on product order :     -Retrieval of a product order or a collection of product orders depending on filter criteria     -Partial update of a product order (including updating rules)    -Creation of a product order (including default values and creation rules)    -Deletion of product order (for administration purposes)     -Notification of events on product order.  **cancelProductOrder resource** This resource is used to request a product order cancellation. Product Order API performs the following operations on product order :     -Retrieval of a cancel product order or a collection of cancel product orders     -Creation of a cancel product order     -Notification of events on cancel product order.   Copyright © TM Forum 2019. All Rights Reserved   
 *
 * API version: 4.0.0
 * Generated by: OpenAPI Generator (https://openapi-generator.tech)
 */

package openapi

import (
	"context"
	"net/http"
	"errors"
)

// NotificationListenersClientSideApiService is a service that implents the logic for the NotificationListenersClientSideApiServicer
// This service should implement the business logic for every endpoint for the NotificationListenersClientSideApi API. 
// Include any external packages or services that will be required by this service.
type NotificationListenersClientSideApiService struct {
}

// NewNotificationListenersClientSideApiService creates a default api service
func NewNotificationListenersClientSideApiService() NotificationListenersClientSideApiServicer {
	return &NotificationListenersClientSideApiService{}
}

// ListenToCancelProductOrderCreateEvent - Client listener for entity CancelProductOrderCreateEvent
func (s *NotificationListenersClientSideApiService) ListenToCancelProductOrderCreateEvent(ctx context.Context, data CancelProductOrderCreateEvent) (ImplResponse, error) {
	// TODO - update ListenToCancelProductOrderCreateEvent with the required logic for this service method.
	// Add api_notification_listeners_client_side_service.go to the .openapi-generator-ignore to avoid overwriting this service implementation when updating open api generation.

	//TODO: Uncomment the next line to return response Response(201, EventSubscription{}) or use other options such as http.Ok ...
	//return Response(201, EventSubscription{}), nil

	//TODO: Uncomment the next line to return response Response(400, Error{}) or use other options such as http.Ok ...
	//return Response(400, Error{}), nil

	//TODO: Uncomment the next line to return response Response(401, Error{}) or use other options such as http.Ok ...
	//return Response(401, Error{}), nil

	//TODO: Uncomment the next line to return response Response(403, Error{}) or use other options such as http.Ok ...
	//return Response(403, Error{}), nil

	//TODO: Uncomment the next line to return response Response(404, Error{}) or use other options such as http.Ok ...
	//return Response(404, Error{}), nil

	//TODO: Uncomment the next line to return response Response(405, Error{}) or use other options such as http.Ok ...
	//return Response(405, Error{}), nil

	//TODO: Uncomment the next line to return response Response(409, Error{}) or use other options such as http.Ok ...
	//return Response(409, Error{}), nil

	//TODO: Uncomment the next line to return response Response(500, Error{}) or use other options such as http.Ok ...
	//return Response(500, Error{}), nil

	return Response(http.StatusNotImplemented, nil), errors.New("ListenToCancelProductOrderCreateEvent method not implemented")
}

// ListenToCancelProductOrderInformationRequiredEvent - Client listener for entity CancelProductOrderInformationRequiredEvent
func (s *NotificationListenersClientSideApiService) ListenToCancelProductOrderInformationRequiredEvent(ctx context.Context, data CancelProductOrderInformationRequiredEvent) (ImplResponse, error) {
	// TODO - update ListenToCancelProductOrderInformationRequiredEvent with the required logic for this service method.
	// Add api_notification_listeners_client_side_service.go to the .openapi-generator-ignore to avoid overwriting this service implementation when updating open api generation.

	//TODO: Uncomment the next line to return response Response(201, EventSubscription{}) or use other options such as http.Ok ...
	//return Response(201, EventSubscription{}), nil

	//TODO: Uncomment the next line to return response Response(400, Error{}) or use other options such as http.Ok ...
	//return Response(400, Error{}), nil

	//TODO: Uncomment the next line to return response Response(401, Error{}) or use other options such as http.Ok ...
	//return Response(401, Error{}), nil

	//TODO: Uncomment the next line to return response Response(403, Error{}) or use other options such as http.Ok ...
	//return Response(403, Error{}), nil

	//TODO: Uncomment the next line to return response Response(404, Error{}) or use other options such as http.Ok ...
	//return Response(404, Error{}), nil

	//TODO: Uncomment the next line to return response Response(405, Error{}) or use other options such as http.Ok ...
	//return Response(405, Error{}), nil

	//TODO: Uncomment the next line to return response Response(409, Error{}) or use other options such as http.Ok ...
	//return Response(409, Error{}), nil

	//TODO: Uncomment the next line to return response Response(500, Error{}) or use other options such as http.Ok ...
	//return Response(500, Error{}), nil

	return Response(http.StatusNotImplemented, nil), errors.New("ListenToCancelProductOrderInformationRequiredEvent method not implemented")
}

// ListenToCancelProductOrderStateChangeEvent - Client listener for entity CancelProductOrderStateChangeEvent
func (s *NotificationListenersClientSideApiService) ListenToCancelProductOrderStateChangeEvent(ctx context.Context, data CancelProductOrderStateChangeEvent) (ImplResponse, error) {
	// TODO - update ListenToCancelProductOrderStateChangeEvent with the required logic for this service method.
	// Add api_notification_listeners_client_side_service.go to the .openapi-generator-ignore to avoid overwriting this service implementation when updating open api generation.

	//TODO: Uncomment the next line to return response Response(201, EventSubscription{}) or use other options such as http.Ok ...
	//return Response(201, EventSubscription{}), nil

	//TODO: Uncomment the next line to return response Response(400, Error{}) or use other options such as http.Ok ...
	//return Response(400, Error{}), nil

	//TODO: Uncomment the next line to return response Response(401, Error{}) or use other options such as http.Ok ...
	//return Response(401, Error{}), nil

	//TODO: Uncomment the next line to return response Response(403, Error{}) or use other options such as http.Ok ...
	//return Response(403, Error{}), nil

	//TODO: Uncomment the next line to return response Response(404, Error{}) or use other options such as http.Ok ...
	//return Response(404, Error{}), nil

	//TODO: Uncomment the next line to return response Response(405, Error{}) or use other options such as http.Ok ...
	//return Response(405, Error{}), nil

	//TODO: Uncomment the next line to return response Response(409, Error{}) or use other options such as http.Ok ...
	//return Response(409, Error{}), nil

	//TODO: Uncomment the next line to return response Response(500, Error{}) or use other options such as http.Ok ...
	//return Response(500, Error{}), nil

	return Response(http.StatusNotImplemented, nil), errors.New("ListenToCancelProductOrderStateChangeEvent method not implemented")
}

// ListenToProductOrderAttributeValueChangeEvent - Client listener for entity ProductOrderAttributeValueChangeEvent
func (s *NotificationListenersClientSideApiService) ListenToProductOrderAttributeValueChangeEvent(ctx context.Context, data ProductOrderAttributeValueChangeEvent) (ImplResponse, error) {
	// TODO - update ListenToProductOrderAttributeValueChangeEvent with the required logic for this service method.
	// Add api_notification_listeners_client_side_service.go to the .openapi-generator-ignore to avoid overwriting this service implementation when updating open api generation.

	//TODO: Uncomment the next line to return response Response(201, EventSubscription{}) or use other options such as http.Ok ...
	//return Response(201, EventSubscription{}), nil

	//TODO: Uncomment the next line to return response Response(400, Error{}) or use other options such as http.Ok ...
	//return Response(400, Error{}), nil

	//TODO: Uncomment the next line to return response Response(401, Error{}) or use other options such as http.Ok ...
	//return Response(401, Error{}), nil

	//TODO: Uncomment the next line to return response Response(403, Error{}) or use other options such as http.Ok ...
	//return Response(403, Error{}), nil

	//TODO: Uncomment the next line to return response Response(404, Error{}) or use other options such as http.Ok ...
	//return Response(404, Error{}), nil

	//TODO: Uncomment the next line to return response Response(405, Error{}) or use other options such as http.Ok ...
	//return Response(405, Error{}), nil

	//TODO: Uncomment the next line to return response Response(409, Error{}) or use other options such as http.Ok ...
	//return Response(409, Error{}), nil

	//TODO: Uncomment the next line to return response Response(500, Error{}) or use other options such as http.Ok ...
	//return Response(500, Error{}), nil

	return Response(http.StatusNotImplemented, nil), errors.New("ListenToProductOrderAttributeValueChangeEvent method not implemented")
}

// ListenToProductOrderCreateEvent - Client listener for entity ProductOrderCreateEvent
func (s *NotificationListenersClientSideApiService) ListenToProductOrderCreateEvent(ctx context.Context, data ProductOrderCreateEvent) (ImplResponse, error) {
	// TODO - update ListenToProductOrderCreateEvent with the required logic for this service method.
	// Add api_notification_listeners_client_side_service.go to the .openapi-generator-ignore to avoid overwriting this service implementation when updating open api generation.

	//TODO: Uncomment the next line to return response Response(201, EventSubscription{}) or use other options such as http.Ok ...
	//return Response(201, EventSubscription{}), nil

	//TODO: Uncomment the next line to return response Response(400, Error{}) or use other options such as http.Ok ...
	//return Response(400, Error{}), nil

	//TODO: Uncomment the next line to return response Response(401, Error{}) or use other options such as http.Ok ...
	//return Response(401, Error{}), nil

	//TODO: Uncomment the next line to return response Response(403, Error{}) or use other options such as http.Ok ...
	//return Response(403, Error{}), nil

	//TODO: Uncomment the next line to return response Response(404, Error{}) or use other options such as http.Ok ...
	//return Response(404, Error{}), nil

	//TODO: Uncomment the next line to return response Response(405, Error{}) or use other options such as http.Ok ...
	//return Response(405, Error{}), nil

	//TODO: Uncomment the next line to return response Response(409, Error{}) or use other options such as http.Ok ...
	//return Response(409, Error{}), nil

	//TODO: Uncomment the next line to return response Response(500, Error{}) or use other options such as http.Ok ...
	//return Response(500, Error{}), nil

	return Response(http.StatusNotImplemented, nil), errors.New("ListenToProductOrderCreateEvent method not implemented")
}

// ListenToProductOrderDeleteEvent - Client listener for entity ProductOrderDeleteEvent
func (s *NotificationListenersClientSideApiService) ListenToProductOrderDeleteEvent(ctx context.Context, data ProductOrderDeleteEvent) (ImplResponse, error) {
	// TODO - update ListenToProductOrderDeleteEvent with the required logic for this service method.
	// Add api_notification_listeners_client_side_service.go to the .openapi-generator-ignore to avoid overwriting this service implementation when updating open api generation.

	//TODO: Uncomment the next line to return response Response(201, EventSubscription{}) or use other options such as http.Ok ...
	//return Response(201, EventSubscription{}), nil

	//TODO: Uncomment the next line to return response Response(400, Error{}) or use other options such as http.Ok ...
	//return Response(400, Error{}), nil

	//TODO: Uncomment the next line to return response Response(401, Error{}) or use other options such as http.Ok ...
	//return Response(401, Error{}), nil

	//TODO: Uncomment the next line to return response Response(403, Error{}) or use other options such as http.Ok ...
	//return Response(403, Error{}), nil

	//TODO: Uncomment the next line to return response Response(404, Error{}) or use other options such as http.Ok ...
	//return Response(404, Error{}), nil

	//TODO: Uncomment the next line to return response Response(405, Error{}) or use other options such as http.Ok ...
	//return Response(405, Error{}), nil

	//TODO: Uncomment the next line to return response Response(409, Error{}) or use other options such as http.Ok ...
	//return Response(409, Error{}), nil

	//TODO: Uncomment the next line to return response Response(500, Error{}) or use other options such as http.Ok ...
	//return Response(500, Error{}), nil

	return Response(http.StatusNotImplemented, nil), errors.New("ListenToProductOrderDeleteEvent method not implemented")
}

// ListenToProductOrderInformationRequiredEvent - Client listener for entity ProductOrderInformationRequiredEvent
func (s *NotificationListenersClientSideApiService) ListenToProductOrderInformationRequiredEvent(ctx context.Context, data ProductOrderInformationRequiredEvent) (ImplResponse, error) {
	// TODO - update ListenToProductOrderInformationRequiredEvent with the required logic for this service method.
	// Add api_notification_listeners_client_side_service.go to the .openapi-generator-ignore to avoid overwriting this service implementation when updating open api generation.

	//TODO: Uncomment the next line to return response Response(201, EventSubscription{}) or use other options such as http.Ok ...
	//return Response(201, EventSubscription{}), nil

	//TODO: Uncomment the next line to return response Response(400, Error{}) or use other options such as http.Ok ...
	//return Response(400, Error{}), nil

	//TODO: Uncomment the next line to return response Response(401, Error{}) or use other options such as http.Ok ...
	//return Response(401, Error{}), nil

	//TODO: Uncomment the next line to return response Response(403, Error{}) or use other options such as http.Ok ...
	//return Response(403, Error{}), nil

	//TODO: Uncomment the next line to return response Response(404, Error{}) or use other options such as http.Ok ...
	//return Response(404, Error{}), nil

	//TODO: Uncomment the next line to return response Response(405, Error{}) or use other options such as http.Ok ...
	//return Response(405, Error{}), nil

	//TODO: Uncomment the next line to return response Response(409, Error{}) or use other options such as http.Ok ...
	//return Response(409, Error{}), nil

	//TODO: Uncomment the next line to return response Response(500, Error{}) or use other options such as http.Ok ...
	//return Response(500, Error{}), nil

	return Response(http.StatusNotImplemented, nil), errors.New("ListenToProductOrderInformationRequiredEvent method not implemented")
}

// ListenToProductOrderStateChangeEvent - Client listener for entity ProductOrderStateChangeEvent
func (s *NotificationListenersClientSideApiService) ListenToProductOrderStateChangeEvent(ctx context.Context, data ProductOrderStateChangeEvent) (ImplResponse, error) {
	// TODO - update ListenToProductOrderStateChangeEvent with the required logic for this service method.
	// Add api_notification_listeners_client_side_service.go to the .openapi-generator-ignore to avoid overwriting this service implementation when updating open api generation.

	//TODO: Uncomment the next line to return response Response(201, EventSubscription{}) or use other options such as http.Ok ...
	//return Response(201, EventSubscription{}), nil

	//TODO: Uncomment the next line to return response Response(400, Error{}) or use other options such as http.Ok ...
	//return Response(400, Error{}), nil

	//TODO: Uncomment the next line to return response Response(401, Error{}) or use other options such as http.Ok ...
	//return Response(401, Error{}), nil

	//TODO: Uncomment the next line to return response Response(403, Error{}) or use other options such as http.Ok ...
	//return Response(403, Error{}), nil

	//TODO: Uncomment the next line to return response Response(404, Error{}) or use other options such as http.Ok ...
	//return Response(404, Error{}), nil

	//TODO: Uncomment the next line to return response Response(405, Error{}) or use other options such as http.Ok ...
	//return Response(405, Error{}), nil

	//TODO: Uncomment the next line to return response Response(409, Error{}) or use other options such as http.Ok ...
	//return Response(409, Error{}), nil

	//TODO: Uncomment the next line to return response Response(500, Error{}) or use other options such as http.Ok ...
	//return Response(500, Error{}), nil

	return Response(http.StatusNotImplemented, nil), errors.New("ListenToProductOrderStateChangeEvent method not implemented")
}

